//
//  Shader.fsh
//  ios
//
//  Created by Adam Berger on 1/28/13.
//  Copyright (c) 2013 Auxbrain, Inc. All rights reserved.
//

varying lowp vec2 uv1Varying;
varying lowp vec2 uv2Varying;
varying lowp float v_fog;

uniform sampler2D texture;
uniform sampler2D lightmap;

void main()
{
    
    gl_FragColor = texture2D(texture, uv1Varying);
    gl_FragColor.w = 1.0;
    
    highp vec4 decal = texture2D(lightmap, uv2Varying);
    decal = 2.0*decal - vec4(1.0, 1.0, 1.0, 1.0);
    gl_FragColor.xyz = gl_FragColor.xyz + decal.xyz;
    
    
    ADD_FOG(v_fog, STANDARD_FOG_COLOR);
}
