//
//  Shader.fsh
//  ios
//
//  Created by Adam Berger on 1/28/13.
//  Copyright (c) 2013 Auxbrain, Inc. All rights reserved.
//

uniform sampler2D diffuse;
uniform sampler2D decal;
uniform sampler2D lightmap;
uniform highp float lightmap_scale;

varying lowp vec2 uv1Varying;
varying lowp vec2 uv2Varying;
varying lowp vec2 v_uv3;
varying lowp float v_fog;

void main()
{

    gl_FragColor = texture2D(diffuse, uv1Varying);
    highp vec3 lm = texture2D(lightmap, uv2Varying).xyz;
    lowp vec4 decal = texture2D(decal, v_uv3);
    gl_FragColor.xyz = gl_FragColor.xyz*(1.0 - decal.w) + decal.xyz*decal.w;
    gl_FragColor.w = 1.0;
    
    gl_FragColor.xyz = gl_FragColor.xyz * lm*lightmap_scale;
    
    ADD_FOG(v_fog, STANDARD_FOG_COLOR);
}
