//
//  Shader.fsh
//  ios
//
//  Created by Adam Berger on 1/28/13.
//  Copyright (c) 2013 Auxbrain, Inc. All rights reserved.
//



uniform sampler2D diffuse;
uniform sampler2D lightmap;
uniform SHADOW_SAMPLER_FD shadowmap;
uniform lowp float lightmap_scale;
uniform lowp float ambient_light;

varying highp vec2 uv1Varying;
varying highp vec2 uv2Varying;
varying lowp float v_fog;
varying highp vec4 v_shadow_coord;

void main()
{
    gl_FragColor = texture2D(diffuse, uv1Varying);
    lowp vec4 lm = texture2D(lightmap, uv2Varying);
    lowp float shadowVal = CALC_SHADOW_VAL_FD(shadowmap, v_shadow_coord);

    lm = lm*lightmap_scale;
    lowp float shadowValInv = 1.0-shadowVal;
    gl_FragColor.xyz = (gl_FragColor.xyz * lm.xyz * shadowVal) + (gl_FragColor.xyz * ambient_light * shadowValInv);
    
    ADD_FOG(v_fog, STANDARD_FOG_COLOR);
}
