//
//  Shader.vsh
//  ios
//
//  Created by Adam Berger on 1/28/13.
//  Copyright (c) 2013 Auxbrain, Inc. All rights reserved.
//

attribute vec4 position;
attribute vec2 uv1;
attribute float metadata;

varying highp vec2 frag_uv1;

uniform mat4 mMatrix;
uniform mat4 vpMatrix;
uniform float offset;
uniform float curve;

void main()
{
    vec4 pos = mMatrix * position;
    pos.z += pow(metadata, curve) * offset;
    gl_Position = vpMatrix * pos;
    frag_uv1 = uv1;
}
