//
//  Shader.vsh
//  ios
//
//  Created by Adam Berger on 1/28/13.
//  Copyright (c) 2013 Auxbrain, Inc. All rights reserved.
//

attribute vec4 position;
attribute vec2 uv1;
attribute vec3 normal;
attribute vec4 color;


varying lowp vec4 v_color;
varying lowp float v_light_amt;
varying highp vec4 v_shadow_coord;

uniform lowp vec3 light_dir;
uniform mat4 mMatrix;
uniform mat4 vpMatrix;
uniform mat4 mvpMatrix;
uniform mat4 mvpMatrixShadow;
uniform mat3 normalMatrix;

void main()
{
    vec3 normal = normalize(normalMatrix * normal);
    v_color = color;
    
    vec4 world_position = mMatrix * position;
    gl_Position = mvpMatrix * position;
    
    v_light_amt = max(0.0, dot(normal, normalize(light_dir)) - 0.1);
    v_shadow_coord = (mvpMatrixShadow * world_position);
    v_shadow_coord.z -= 0.001;
    
}
