//
//  Shader.fsh
//  ios
//
//  Created by Adam Berger on 1/28/13.
//  Copyright (c) 2013 Auxbrain, Inc. All rights reserved.
//

varying lowp vec4 v_color;

uniform lowp vec4 color;
uniform lowp vec4 fog_color;
uniform lowp float fog_near;
uniform lowp float fog_far;
uniform lowp float fog_density;

void main()
{
//    gl_FragColor = v_color;
    gl_FragColor.xyz = v_color.xyz;
    gl_FragColor.xyz = gl_FragColor.xyz*(1.0 - v_color.w) + v_color.xyz*v_color.w;
    lowp float alpha = gl_FragColor.x * v_color.w * color.w;
    lowp float zclip = gl_FragCoord.z / gl_FragCoord.w;
    lowp float fog_factor = clamp((zclip - fog_near) / (fog_far - fog_near), 0.0, 1.0);
    gl_FragColor = mix(gl_FragColor, fog_color, fog_factor*fog_density*0.2);
    
    gl_FragColor.w = alpha;

}
