//
//  Shader.vsh
//  ios
//
//  Created by Kevin Pazirandeh on 1/28/13.
//  Copyright (c) 2013 Auxbrain, Inc. All rights reserved.
//

attribute vec4 position;
attribute vec4 color;
attribute vec3 normal;

varying vec4 v_color;

uniform mat4 mMatrix;
uniform mat4 vpMatrix;
uniform mat4 viewInverse;
uniform mat3 normalMatrix;


void main()
{
    vec4 worldPosition = mMatrix * position;
    gl_Position = vpMatrix * worldPosition;
    
    vec3 vert_normal = normalize(normalMatrix * normal);
    vec3 view_dir = normalize(vec3(viewInverse * vec4(0.0, 0.0, 0.0, 1.0) - mMatrix * position));
    float nDotVP = max(0.0, dot(vert_normal, view_dir));

    float alpha = 0.1 + 0.9*pow(nDotVP, 2.0);
    v_color = color;
    v_color.a = 1.0-alpha;
}
