//
//  Shader.vsh
//  ios
//
//  Created by Adam Berger on 1/28/13.
//  Copyright (c) 2013 Auxbrain, Inc. All rights reserved.
//

attribute vec4 position;
attribute vec2 uv1;
attribute vec3 normal;
attribute vec4 binormal;

varying lowp vec4 colorVarying;
varying lowp vec2 frag_uv1;
varying lowp vec4 v_position;
varying lowp vec3 v_normal;
varying lowp float v_fog;
varying highp vec4 shadowCoord;

VARYING_MAT3(tangentSpace);

uniform mat4 mMatrix;
uniform mat4 vpMatrix;
uniform mat3 normalMatrix;
uniform mat4 shadowProjection;
uniform float fog_mult;

V_FOG_UNIFORMS


void main()
{
    vec3 n = normalize(normalMatrix * normal);
    vec3 t = normalize(normalMatrix * binormal.xyz);
    
    colorVarying.xyz = vec3(0);
    frag_uv1 = uv1;
    v_position = position;
    v_normal = normal;
    
    
    vec4 worldPosition = mMatrix * position;
    gl_Position = vpMatrix * worldPosition;
    v_fog = PARAM_FOG(fog_mult);

    vec3 b = -normalize(cross(n, t))*binormal.w;

    STORE_MAT3_VARYING(tangentSpace,
    t.x, t.y, t.z,
    b.x, b.y, b.z,
    n.x, n.y, n.z
    );

    shadowCoord = (shadowProjection * worldPosition);
    shadowCoord.z -= 0.001;
}
