//
//  Shader.fsh
//  ios
//
//  Created by Adam Berger on 1/28/13.
//  Copyright (c) 2013 Auxbrain, Inc. All rights reserved.
//


varying lowp vec4 v_color;
varying lowp float v_light_amt;

uniform highp mat4 viewInverse;
uniform highp mat4 mMatrix;
uniform highp mat4 vpMatrix;
uniform highp mat3 normalMatrix;
uniform lowp vec4 color;
uniform lowp vec4 ambient_light_color;
uniform lowp vec3 light_dir;
uniform lowp vec4 fog_color;
uniform lowp float fog_near;
uniform lowp float fog_far;
uniform lowp float fog_density;

void main()
{
    
//    lowp vec3 lightDirection = normalize(light_dir);
    lowp float fog_illum = (clamp(dot(vec3(0.2, 0.7, 0.1), v_color.xyz)*v_color.w, 0.4, 0.9)-0.4)/0.5;
    gl_FragColor.xyz = (ambient_light_color.xyz  + (pow(v_light_amt, 0.25) * color.xyz)) * v_color.xyz;
    gl_FragColor.xyz = gl_FragColor.xyz*(1.0 - v_color.w) + v_color.xyz*v_color.w;
    gl_FragColor.w = 1.0;
    
    lowp float zclip = gl_FragCoord.z / gl_FragCoord.w;
    lowp float fog_base = clamp((zclip - fog_near) / (fog_far - fog_near), 0.0, 1.0) * fog_density;
    lowp float fog_factor = fog_base * (1.0 - fog_illum);
    gl_FragColor.xyz +=  fog_base * sqrt(fog_illum) * fog_color.xyz;
    gl_FragColor = mix(gl_FragColor, fog_color, fog_factor);
    
    gl_FragColor.w = 1.0;
    

    

}
