//
//  Shader.vsh
//  ios
//
//  Created by Adam Berger on 1/28/13.
//  Copyright (c) 2013 Auxbrain, Inc. All rights reserved.
//

attribute vec4 position;
attribute vec2 uv1;

varying highp vec2 frag_uv1;
varying lowp vec2 v_blurTexCoords[9];

uniform mat4 mvpMatrix;
uniform highp vec2 pixel_offset;


void main()
{
    gl_Position = mvpMatrix * position;
    frag_uv1 = uv1;
    
    v_blurTexCoords[ 0] = frag_uv1 + vec2(-2.0*pixel_offset.x, -2.0*pixel_offset.y);
    v_blurTexCoords[ 1] = frag_uv1 + vec2( 0.0,                -2.0*pixel_offset.y);
    v_blurTexCoords[ 2] = frag_uv1 + vec2( 2.0*pixel_offset.x, -2.0*pixel_offset.y);
    v_blurTexCoords[ 3] = frag_uv1 + vec2(-2.0*pixel_offset.x, 0.0);
    v_blurTexCoords[ 4] = frag_uv1 + vec2( 0.0,                0.0);
    v_blurTexCoords[ 5] = frag_uv1 + vec2( 2.0*pixel_offset.x, 0.0);
    v_blurTexCoords[ 6] = frag_uv1 + vec2(-2.0*pixel_offset.x, 2.0*pixel_offset.y);
    v_blurTexCoords[ 7] = frag_uv1 + vec2( 0.0,                2.0*pixel_offset.y);
    v_blurTexCoords[ 8] = frag_uv1 + vec2( 2.0*pixel_offset.x, 2.0*pixel_offset.y);

}
