//
//  Shader.vsh
//  ios
//
//  Created by Adam Berger on 1/28/13.
//  Copyright (c) 2013 Auxbrain, Inc. All rights reserved.
//

attribute vec4 position;
attribute vec2 uv1;

varying highp vec2 frag_uv1;
varying lowp float v_fog;

varying lowp vec2 v_blurTexCoords[5];

uniform mat4 mvpMatrix;
uniform float fog_mult;
uniform highp vec2 pixel_offset;

//uniform float offset[3] = float[]( 0.0, 1.3846153846, 3.2307692308 );

//uniform float weight[3] = float[]( 0.2270270270, 0.3162162162, 0.0702702703 )

void main()
{
    gl_Position = mvpMatrix * position;
    frag_uv1 = uv1;
    v_fog = STD_FOG(fog_mult);
    
    v_blurTexCoords[ 0] = frag_uv1 + vec2(-2.0*pixel_offset.x, -2.0*pixel_offset.y);
    v_blurTexCoords[ 1] = frag_uv1 + vec2( 2.0*pixel_offset.x, -2.0*pixel_offset.y);
    v_blurTexCoords[ 2] = frag_uv1 + vec2( 0.0,                0.0);
    v_blurTexCoords[ 3] = frag_uv1 + vec2( 2.0*pixel_offset.x, 2.0*pixel_offset.y);
    v_blurTexCoords[ 4] = frag_uv1 + vec2(-2.0*pixel_offset.x, 2.0*pixel_offset.y);
//    v_blurTexCoords[ 4] = frag_uv1 + (-3.0*pixel_offset);
//    v_blurTexCoords[ 5] = frag_uv1 + (-2.0*pixel_offset);
//    v_blurTexCoords[ 6] = frag_uv1 + (-1.0*pixel_offset);
//    v_blurTexCoords[ 7] = frag_uv1 + (1.0*pixel_offset);
//    v_blurTexCoords[ 8] = frag_uv1 +  (2.0*pixel_offset);
//    v_blurTexCoords[ 9] = frag_uv1 +  (3.0*pixel_offset);
//    v_blurTexCoords[10] = frag_uv1 +  (4.0*pixel_offset);
//    v_blurTexCoords[11] = frag_uv1 +  (5.0*pixel_offset);
//    v_blurTexCoords[12] = frag_uv1 +  (6.0*pixel_offset);
//    v_blurTexCoords[13] = frag_uv1 +  (7.0*pixel_offset);
}
