//
//  Prefix
//  ios
//
//  Created by Kevin Pazirandeh
//  Copyright (c) 2013 Auxbrain, Inc. All rights reserved.
//

#extension GL_EXT_shadow_samplers : require

// only usd for the ground
#define AMBIENT_BASE 0.1
#define AMBIENT_VARIABLE 0.40
#define DIFFUSE_VARIABLE 1.1

#define STD_LIGHT_COLOR vec4(1.0, 0.95, 0.8, 1.0)

#define M_PI 3.14159

#define FUNC_LIGHTING_SHADOW(COLOR, SHADOW_MAP, SHADOW_VAL) FUNC_LIGHTING_SHADOW_COMP(COLOR, STD_LIGHT_COLOR, SHADOW_MAP.x, SHADOW_MAP.w, SHADOW_VAL)
#define FUNC_LIGHTING_SHADOW_COMP(COLOR, LIGHT_COLOR, SHADOW_DIRECT, SHADOW_AMB, SHADOW_DYN) COLOR.xyz*(AMBIENT_BASE + AMBIENT_VARIABLE*(SHADOW_AMB)) + COLOR.xyz*(SHADOW_AMB * SHADOW_DIRECT*SHADOW_DYN*DIFFUSE_VARIABLE)*LIGHT_COLOR.xyz

#define NORMAL_MAP_LIGHTING(LIGHT_COLOR) (gl_FragColor.xyz) * (vec3(0.9, 0.9, 1.0)*(0.15 + 0.7)*ambient_mult) + gl_FragColor.xyz*(nDotVP*LIGHT_COLOR*1.2 + specularReflection*1.5)*shadowVal*diffuse_mult


#define NORMAL_MAP_LIGHTING_LOW(LIGHT_COLOR) (gl_FragColor.xyz) * (vec3(0.9, 0.9, 1.0)*(0.15 + 0.7*ambient_mult)) + gl_FragColor.xyz*(nDotVP*LIGHT_COLOR*0.9)*shadowVal*diffuse_mult

//195 168 122
#define STANDARD_FOG_COLOR vec3(0.70, 0.659, 0.58)*1.4
//#define STANDARD_FOG_COLOR lowp vec3(1.0, 1.0, 1.0)*1.2
#define FOG(FOG_MULT, START, END, CURVE) pow(min(FOG_MULT, max(0.0, (gl_Position.w - START)/(END-START))), CURVE)
#define STD_FOG(FOG_MULT) FOG(FOG_MULT, -5.0, 190.0, 0.6)
#define PARAM_FOG(FOG_MULT) FOG(FOG_MULT, fog_params.x, fog_params.y, fog_params.z)
#define ADD_FOG(FOG_AMT, FOG_COLOR) gl_FragColor.xyz = gl_FragColor.xyz * (1.0 - FOG_AMT) + FOG_COLOR * FOG_AMT

#define V_FOG_UNIFORMS uniform highp vec4 fog_params; // x:start y:end z:curve
#define F_FOG_UNIFORMS uniform lowp vec3 fog_color; //fog color

#define SHADOW_SAMPLER sampler2D
#define CALC_SHADOW_VAL(shadow, shadowCoord) texture2DProj(shadow, shadowCoord).x

#define SHADOW_SAMPLER_FD sampler2DShadow
#define CALC_SHADOW_VAL_FD(shadow, shadowCoord) shadow2DProjEXT(shadow, shadowCoord)


#define COLOR_CORRECT// gl_FragColor.xyz = pow(gl_FragColor.xyz, vec3(1.0/0.9)) * 1.05 + vec3(0.03); gl_FragColor.y -= sin(gl_FragColor.y * 2.0 * M_PI)*0.04

#define UNIFORM_MAT4_ARRAY(NAME, COUNT) uniform mat4 NAME[COUNT]
#define UNIFORM_MAT3_ARRAY(NAME, COUNT) uniform mat3 NAME[COUNT]

#define VARYING_MAT3(NAME) varying lowp mat3 NAME

#define MAKE_MAT4_FROM_ARRAY(NAME, INDEX) NAME[INDEX]
#define MAKE_MAT3_FROM_ARRAY(NAME, INDEX) NAME[INDEX]

#define MAKE_MAT3_FROM_VARYING(NAME) NAME
#define STORE_MAT3_VARYING(NAME, v1, v2, v3, v4, v5, v6, v7, v8, v9) NAME = mat3(v1, v2, v3, v4, v5, v6, v7, v8, v9);