//
//  Shader.vsh
//  ios
//
//  Created by Adam Berger on 1/28/13.
//  Copyright (c) 2013 Auxbrain, Inc. All rights reserved.
//

attribute vec4 position;
attribute vec3 normal;
attribute vec2 uv1;

varying vec2 frag_uv1;
varying highp vec3 skybox_uv;

uniform mat4 mMatrix;
uniform mat4 vpMatrix;
uniform mat3 normalMatrix;
uniform mat4 viewInverse;

void main()
{
    vec3 normalDirection = normalize(normalMatrix * normal);
    gl_Position = vpMatrix * mMatrix * position;
    frag_uv1 = uv1;
    
    mediump vec3 viewDirection = normalize(vec3(viewInverse * vec4(0.0, 0.0, 0.0, 1.0) - mMatrix * position));
    
    skybox_uv = reflect(-viewDirection, normalDirection);
}
