//
//  Shader.vsh
//  ios
//
//  Created by Kevin Pazirandeh on 1/28/13.
//  Copyright (c) 2013 Auxbrain, Inc. All rights reserved.
//

attribute vec4 position;

uniform mat4 mvpMatrix;

uniform float arc_len;
uniform float offset;


void main()
{
    vec4 cartesian_position = position;
    cartesian_position.y *= arc_len/3.14159;
    cartesian_position.y += offset;
    
    vec4 polar_position = vec4(0, 0, cartesian_position.z, cartesian_position.w);
    polar_position.x = cartesian_position.x * cos(cartesian_position.y);
    polar_position.y = cartesian_position.x * sin(cartesian_position.y);
    
    gl_Position = mvpMatrix * polar_position;
}
