//
//  Shader.fsh
//  ios
//
//  Created by Adam Berger on 1/28/13.
//  Copyright (c) 2013 Auxbrain, Inc. All rights reserved.
//

varying lowp vec2 v_uv1;

uniform sampler2D texture;
uniform lowp vec4 light_color;
uniform lowp vec4 dark_color;
uniform lowp vec4 color;

void main()
{
    lowp vec3 lw = vec3(0.3, 0.6, 0.1);
    
    lowp vec4 result = texture2D(texture, v_uv1);
    lowp float orig_a = result.w;
    lowp float lum = dot(lw, result.xyz);
    lowp vec4 inverse = vec4(1,1,1,1) - result;
    result = light_color * lum + dark_color * (1.0 - lum);
    result.w *= orig_a;
    gl_FragColor = result*color;
}
