//
//  Shader.fsh
//  ios
//
//  Created by Adam Berger on 1/28/13.
//  Copyright (c) 2013 Auxbrain, Inc. All rights reserved.
//

varying lowp vec2 v_uv1;
varying lowp vec4 v_color;

uniform sampler2D texture;
uniform lowp vec4 light_color;
uniform lowp vec4 dark_color;
uniform lowp vec4 color;

void main()
{
    lowp vec4 tex = texture2D(texture, v_uv1);
    lowp vec4 inv = vec4(1,1,1,1) - v_color; // inverse = 1,1,1,1 for top
    lowp vec4 result = v_color*light_color; // result = 0,0,0,0 * 1,0,0,0.5 = 0,0,0,0
    result += dark_color*inv; // result = 0 + blue*
    gl_FragColor = result*tex*color;
}
